/*
************************************************************************
*
*   ExQuit.c - Quit command
*
*   Copyright (c) 1994
*
*   ETH Zuerich
*   Institut fuer Molekularbiologie und Biophysik
*   ETH-Hoenggerberg
*   CH-8093 Zuerich
*
*   SPECTROSPIN AG
*   Industriestr. 26
*   CH-8117 Faellanden
*
*   All Rights Reserved
*
*   Date of last modification : 95/04/09
*   Pathname of SCCS file     : /sgiext/molmol/src/cmdmisc/SCCS/s.ExQuit.c
*   SCCS identification       : 1.2
*
************************************************************************
*/

#include <cmd_misc.h>

#include <stdlib.h>

#include <io.h>
#include <arg.h>
#include <par_names.h>
#include <par_hand.h>

#define ENUM_SIZE 2

ErrCode
ExQuit(char *cmd)
{
  ArgDescr arg;
  EnumEntryDescr enumEntry[ENUM_SIZE];
  ErrCode errCode;

  arg.type = AT_ENUM;

  ArgInit(&arg, 1);

  enumEntry[0].str = "yes";
  enumEntry[0].onOff = TRUE;
  enumEntry[1].str = "no";
  enumEntry[1].onOff = FALSE;

  arg.prompt = "Save State?";
  arg.u.enumD.entryP = enumEntry;
  arg.u.enumD.n = ENUM_SIZE;
  arg.v.intVal = 0;

  errCode = ArgGet(&arg, 1);
  if (errCode != EC_OK) {
    ArgCleanup(&arg, 1);
    return errCode;
  }

  if (arg.v.intVal == 0)
    ParSetIntVal(PN_SAVE_STATE, 1);
  else
    ParSetIntVal(PN_SAVE_STATE, 0);

  ArgCleanup(&arg, 1);

  (void) IOCleanup();
  exit(0);
}
